using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AR;

namespace Project
{
    public partial class FMain
    {
        async public Task<bool> _SM_RUN_STARTCHKSW(bool isFirst, TimeSpan stepTime)
        {
            var mc = PUB.Result.mModel;
            var mv = PUB.Result.vModel;

            double free = 0;
            var savepath = PUB.getSavePath(out free);
            if (free < 3.0)
            {
                string msg = "FREE SPACE ERROR\n" +
                    "디스크 공간(3%)이 부족하여 작업을 진행할 수 없습니다\n" +
                 "저장경로 : {0}\n" +
                 "데이터를 삭제하거나 설정의 삭제주기를 확인하세요";
                msg = string.Format(msg, AR.SETTING.Data.GetDataPath());
                PUB.popup.setMessage(msg);
                DIO.SetBuzzer(true);
                PUB.sm.SetNewStep(eSMStep.IDLE);
                return false;
            }



            if (PUB.Result.isSetmModel == false)
            {
                string msg = "모션모델이 선택되지 않았습니다\n작업모델의 'MOTION'항목을 확인하세요";
                PUB.popup.setMessage(msg);
                DIO.SetBuzzer(true);
                PUB.sm.SetNewStep(eSMStep.IDLE);
                return false;
            }


            //모션의 모든 위치가 원점이 아니라면 홈 초기화를 요청한다.
            var initMsg = "";

            if (initMsg != "")
            {
                PUB.popup.setMessage(initMsg);
                DIO.SetBuzzer(true);
                PUB.sm.SetNewStep(eSMStep.IDLE);
                return false;
            }

            //모델정보가 설정되어있는지 확인
            if (PUB.Result == null ||
                PUB.Result.vModel == null ||
                PUB.Result.vModel.Title.isEmpty())
            {
                PUB.Result.SetResultMessage(eResult.SETUP, eECode.NOMODELV, eNextStep.ERROR);
                return false;
            }

            //모션모델자동선택 230823
            var motionmode = VAR.BOOL[eVarBool.Use_Conveyor] ? "Conveyor" : "Default";
            if (PUB.SelectModelM(motionmode) == false)
            {
                PUB.Result.SetResultMessage(eResult.SETUP, eECode.NOMODELM, eNextStep.ERROR);
                return false;
            }

            //모델정보가 설정되어있는지 확인
            if (PUB.Result == null ||
                PUB.Result.mModel == null ||
                PUB.Result.mModel.Title.isEmpty())
            {
                PUB.Result.SetResultMessage(eResult.SETUP, eECode.NOMODELM, eNextStep.ERROR);
                return false;
            }

            //ECS데이터확인 230823
            var conv = VAR.BOOL[eVarBool.Use_Conveyor];
            if (conv)
            {
                var sidinfo = await PUB.UpdateSIDInfo();
                var systembypass = SETTING.Data.SystemBypass;
                if (systembypass == false && sidinfo.Item1 == false)
                {
                    PUB.Result.SetResultMessage(eResult.SETUP, eECode.NOECSDATA, eNextStep.ERROR, sidinfo.Item2);
                    return false;
                }
                //else if (systembypass == false && sidinfo.Item3 < 1)
                //{
                //    PUB.Result.SetResultMessage(eResult.SETUP, eECode.NOECSDATAACTIVE, eNextStep.ERROR, sidinfo.Item2);
                //    return false;
                //}
            }

            //SID변환정보  필요  230823
            //이값도  테이블에서  실시간으로  조회되므로  미리  불러올  필요  없다

            //사용자추가정보  필요  230823
            //기존에  사용하던  사용자  추가 정보
            //ECS정보가  수신되면  기존 TABLE 을  삭제하는  구조이므로  병행할수  없음
            //데이터는  테이블에서  실시간으로  조 회됨

            //사용자스텝실행
            if (PUB.flag.get(eVarBool.FG_USERSTEP))
            {
                PUB.flag.set(eVarBool.FG_USERSTEP, false, "STACHKSW");
                PUB.log.AddI("작업 시작으로 인해 H/W검사 무시기능을 해제 함");
            }

            //공용변수초기화
            PUB.log.Add("공용변수(카운트)값 초기화");
            VAR.I32.Clear((int)eVarInt32.LPickOfCount);
            VAR.I32.Clear((int)eVarInt32.LPickOnCount);
            VAR.I32.Clear((int)eVarInt32.RPickOfCount);
            VAR.I32.Clear((int)eVarInt32.RPickOnCount);
            VAR.I32.Clear((int)eVarInt32.PickOfCount);
            VAR.I32.Clear((int)eVarInt32.PickOnCount);
            VAR.I32.Clear((int)eVarInt32.PickOnRetry);  //221102

            PUB.flag.set(eVarBool.FG_RUN_LEFT, false, "POSREST");
            PUB.flag.set(eVarBool.FG_RUN_RIGHT, false, "POSREST");

            VAR.BOOL[eVarBool.JOB_Empty_SIDConvertInfo] = false;


            PUB.Result.ItemDataL.Clear("START_CHKSW");
            PUB.Result.ItemDataC.Clear("START_CHKSW");
            PUB.Result.ItemDataR.Clear("START_CHKSW");

            var modelName = PUB.Result.vModel.Title;
            PUB.Result.BCDPattern = PUB.GetPatterns(modelName, false);
            PUB.Result.BCDIgnorePattern = PUB.GetPatterns(modelName, true);
            PUB.Result.BCDPrintPattern = PUB.GetPrintPatterns();
            PUB.log.Add($"모델패턴로딩:{PUB.Result.BCDPattern.Count}/{PUB.Result.BCDIgnorePattern.Count}");

            //변환SID SID확인여부데이터 삭제
            PUB.Result.DTSidConvertEmptyList.Clear();
            PUB.Result.DTSidConvertMultiList.Clear();

            PUB.Result.JobStartTime = DateTime.Now;
            warninactivelist.Clear();

            //작업락기능해제
            LockPK.Set();
            LockUserL.Set();
            LockUserR.Set();


            return true;
        }
    }
}
